import Composite
class Node(Composite.Composite):
	def __init__(self,name,*kids):
		Composite.Composite.__init__(self)
		self.name=name
		for x in kids:
			self.addChild(x)
	def __str__(self):
		n=self.numChildren()
		if n>0:
			x=self.name+"("
			for i in xrange(self.numChildren()):
				x+=str(self.getChild(i))+','
			return x[:-1]+")"
		else:
			return self.name
t=Node("x",
	Node("v",Node("u"),Node("w")),
	Node("z",Node("y")))
print t
s=t.getChild(0)
t.removeChild(s)
t.addChild(s)
print t
