import Token

class PanicMode:
  def recoverFromError(self,parser):
	#error in input, entering panic mode...
	parser.parseErrorOutput.error(parser.currentToken, \
		": unexpected input")
	# scan ahead for the predicted fiducial
	loop=1
	while loop:
		while not parser.tables.fiducials.contains(parser.currentToken.type):
			parser.getToken()
		for i in parser.predictionStk:
			if i==parser.currentToken.type or \
				parser.tables.firstFiducials.has_key(i) and \
				parser.tables.firstFiducials[i].contains( \
					parser.currentToken.type):
				loop=0
				break
		if loop: parser.getToken()
	#generate replacement text
	while 1:
		if parser.currentToken==None: parser.getToken() #????
		parser.popTop()
		if parser.top==parser.currentToken.type or \
			parser.tables.firstFiducials.has_key(parser.top) and \
			parser.tables.firstFiducials[parser.top].contains( \
				parser.currentToken.type):
			parser.predictionStk.push(parser.top)
			break
		if parser.tables.actions.contains(parser.top):
			if parser.top==parser.tables.backup:
				self.PANIC_GEN_BACKUP(parser)
			elif parser.top==parser.tables.doPendingActions:
				parser.performActions()
			else:
				parser.actionQueue.put(parser.top)
		elif parser.tables.terminals.contains(parser.top):
			parser.putToken(parser.top,Token.mkErrorToken(parser.top))
		else: #a nonterminal
			r=parser.tables.minLengRHS[parser.top]
			for j in xrange(len(r)-1,-1,-1):
				parser.predictionStk.push(r[j])
	return 1 #always successful

  def PANIC_GEN_BACKUP(self,parser):
	parser.tokenQueue.pull()
	s=parser.actionQueue.pull()
	while not parser.tables.terminals.contains(s):
		s=parser.actionQueue.pull()




