""" threadsafe counter objects:
x=counter()
x=counter(initVal)
x.count
x.bump()
x.bump(increment) """

import threading

class counter:
	"creates counter objects"
	def bump(self,by=1):
		self.lock.acquire()
		try:
			self.count+=by
			return self.count
		finally:
			self.lock.release()
	def __init__(self,val=0):
		self.count=val
		self.lock=threading.Lock()
