import types

def find(s,sub,start=0,end=None):
	slen=len(s)
	if end == None: end=slen
	elif end >= slen: end=slen
	elif end < -slen: end=0
	else: end+=slen
	return s.find(sub,start,end)%(end+1)

def splitTree(s,delim):
	if type(s)==types.StringType:
		return reduce(lambda x,y,delim=delim:[x,delim,y],s.split(delim))
	else:
		return [splitTree(s[0],delim),s[1],splitTree(s[2],delim)]


def flatten(t):
	if not type(t)==types.ListType:
		return [t]
	else:
		return reduce(lambda x,y:x+y,map(flatten,t))

def splitMultiple(s,delims):
	for d in delims:
		s=splitTree(s,d)
	return filter(None,flatten(s))


