import threading
class Latch:
	def __init__(self):
		self.lock=threading.Lock()
		self.empty=threading.Condition(self.lock)
		self.full=threading.Condition(self.lock)
	def put(self,x):
		self.lock.acquire()
		try:
			while hasattr(self,'contents'):
				self.empty.wait()
			self.contents=x
			self.full.notify()
		finally: 
			self.lock.release()
	def get(self):
		self.lock.acquire()
		try:
			while not hasattr(self,'contents'):
				self.full.wait()
			x=self.contents
			del self.contents
			self.empty.notify()
			return x
		finally: 
			self.lock.release()
