import RunQueue
import threading
import SharedDB
import sys

def transactionRunStrategy(r,rq):
	c=r.getMemento()
	try:
		r.run()
		return
	except SharedDB.CommitError:
		r.setMemento(c)
		rq.enq(r)
		return
	except:
		cl,ex,tb=sys.exc_info()
		print >>sys.stderr, cl,ex
		import traceback
		traceback.print_tb(tb)
		return

def TransactionQueue():
	return RunQueue.RunQueue( 
		runstrategy=transactionRunStrategy)
